SFML - Simple and Fast Multimedia Library

SFML 2.6.1

- Main Page
- Related Pages
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Static Public Member Functions | List of all members
sf::Sensor Class Reference
Window module

Give access to the real-time state of the sensors. More...

`#include <SFML/Window/Sensor.hpp>`

## Public Types
enum | Type { Accelerometer , Gyroscope , Magnetometer , Gravity , UserAcceleration , Orientation , Count }
| Sensor type. More...

## Static Public Member Functions
static bool | isAvailable (Type sensor)
| Check if a sensor is available on the underlying platform.
static void | setEnabled (Type sensor, bool enabled)
| Enable or disable a sensor.
static Vector3f | getValue (Type sensor)
| Get the current sensor value.

## Detailed Description

Give access to the real-time state of the sensors.

sf::Sensor provides an interface to the state of the various sensors that a device provides.

It only contains static functions, so it's not meant to be instantiated.

This class allows users to query the sensors values at any time and directly, without having to deal with a window and its events. Compared to the SensorChanged event, sf::Sensor can retrieve the state of a sensor at any time (you don't need to store and update its current value on your side).

Depending on the OS and hardware of the device (phone, tablet, ...), some sensor types may not be available. You should always check the availability of a sensor before trying to read it, with the sf::Sensor::isAvailable function.

You may wonder why some sensor types look so similar, for example Accelerometer and Gravity / UserAcceleration. The first one is the raw measurement of the acceleration, and takes into account both the earth gravity and the user movement. The others are more precise: they provide these components separately, which is usually more useful. In fact they are not direct sensors, they are computed internally based on the raw acceleration and other sensors. This is exactly the same for Gyroscope vs Orientation.

Because sensors consume a non-negligible amount of current, they are all disabled by default. You must call sf::Sensor::setEnabled for each sensor in which you are interested.

Usage example:

if (sf::Sensor::isAvailable(sf::Sensor::Gravity))
{
// gravity sensor is available
}
// enable the gravity sensor
sf::Sensor::setEnabled(sf::Sensor::Gravity, true);
// get the current value of gravity
sf::Vector3f gravity = sf::Sensor::getValue(sf::Sensor::Gravity);
sf::Sensor::Gravity
@ Gravity
Measures the direction and intensity of gravity, independent of device acceleration (m/s^2)
Definition Sensor.hpp:55
sf::Sensor::isAvailable
static bool isAvailable(Type sensor)
Check if a sensor is available on the underlying platform.
sf::Sensor::getValue
static Vector3f getValue(Type sensor)
Get the current sensor value.
sf::Sensor::setEnabled
static void setEnabled(Type sensor, bool enabled)
Enable or disable a sensor.
sf::Vector3
Utility template class for manipulating 3-dimensional vectors.
Definition Vector3.hpp:38

Definition at line 42 of file Sensor.hpp.

## Member Enumeration Documentation

## ◆ Type

enum sf::Sensor::Type

Sensor type.

Enumerator
Accelerometer | Measures the raw acceleration (m/s^2)
Gyroscope | Measures the raw rotation rates (degrees/s)
Magnetometer | Measures the ambient magnetic field (micro-teslas)
Gravity | Measures the direction and intensity of gravity, independent of device acceleration (m/s^2)
UserAcceleration | Measures the direction and intensity of device acceleration, independent of the gravity (m/s^2)
Orientation | Measures the absolute 3D orientation (degrees)
Count | Keep last – the total number of sensor types.

Definition at line 50 of file Sensor.hpp.

## Member Function Documentation

## ◆ getValue()

static Vector3f sf::Sensor::getValue | ( | Type | sensor | ) |
| static

Get the current sensor value.

Parameters

  sensor | Sensor to read

Returns
  The current sensor value

## ◆ isAvailable()

static bool sf::Sensor::isAvailable | ( | Type | sensor | ) |
| static

Check if a sensor is available on the underlying platform.

Parameters

  sensor | Sensor to check

Returns
  True if the sensor is available, false otherwise

## ◆ setEnabled()

static void sf::Sensor::setEnabled | ( | Type | sensor,
|  | bool | enabled
| ) |  |
| static

Enable or disable a sensor.

All sensors are disabled by default, to avoid consuming too much battery power. Once a sensor is enabled, it starts sending events of the corresponding type.

This function does nothing if the sensor is unavailable.

Parameters

  sensor | Sensor to enable
  enabled | True to enable, false to disable

The documentation for this class was generated from the following file:

- Sensor.hpp